import core.modules
import core.modules.module_registry
from core.modules.vistrails_module import Module, ModuleError

class ProteinDataBank(Module):
  def compute(self):
    pass

class Protein(ProteinDataBank):
  def compute(self):
    pass

  def getAtomOfType(self, type):
    if self.atoms.has_key(type):
      return self.atoms[type]
    else:
      return 0

  def getHetAtomOfType(self, type):
    if self.hatoms.has_key(type):
      return self.hatoms[type]
    else:
      return 0

  def getSequence(self, seqID):
    if self.sequence.has_key(seqID):
      return self.sequence[seqID].__str__()
    else:
      k = self.sequence.keys().__str__()
      str =  'Invalid Sequence ID ' + k

class PDBParser(ProteinDataBank):

  def parseAtomLine(self,line):
    line = line.split()
    els = len(line)
    type = line[els-1]
    if self.p.atoms.has_key(type):
      self.p.atoms[type] = self.p.atoms[type] + 1
    else:
      self.p.atoms[type] = 1

  def parseSequenceLine(self, line):
    line = line.split()
    els = len(line)
    seqID = line[2]
    if not self.p.sequence.has_key(seqID):
      self.p.sequence[seqID] = []
    
    s = self.p.sequence[seqID]
    
    i = 4
    while i < len(line):
      s.append(line[i])
      i = i + 1

    self.p.sequence[seqID] = s

  def parseHetLine(self, line):
    line = line.split()
    els = len(line)
    type = line[els-1]
    if self.p.hatoms.has_key(type):
      self.p.hatoms[type] = self.p.hatoms[type] + 1
    else:
      self.p.hatoms[type] = 1


  def compute(self):
    f = self.getInputFromPort("File")

    self.p = Protein()
    self.p.atoms = {}
    self.p.sequence = {}
    self.p.hatoms = {}

    fStr = open(f.name, 'r').read()
    lines = fStr.split('\n')
    
    for l in lines:
      if l.startswith('ATOM'):
        self.parseAtomLine(l)
      if l.startswith('SEQRES'):
        self.parseSequenceLine(l)
      if l.startswith('HETATM'):
        self.parseHetLine(l)

    self.setResult("Protein", self.p)

class GetAtoms(ProteinDataBank):
  def compute(self):
    prot = self.getInputFromPort("Protein")
    aType = self.getInputFromPort("Atom Type")
    self.setResult("NumAtoms", prot.getAtomOfType(aType))

class GetHetAtoms(ProteinDataBank):
  def compute(self):
    prot = self.getInputFromPort("Protein")
    aType = self.getInputFromPort("Atom Type")
    self.setResult("NumAtoms", prot.getHetAtomOfType(aType))

class GetSequence(ProteinDataBank):
  def compute(self):
    prot = self.getInputFromPort("Protein")
    sID = self.getInputFromPort("SequenceID")
    self.setResult("Sequence", prot.getSequence(sID))