############################################################################
##
## Copyright (C) 2006-2007 University of Utah. All rights reserved.
##
## This file is part of VisTrails.
##
## This file may be used under the terms of the GNU General Public
## License version 2.0 as published by the Free Software Foundation
## and appearing in the file LICENSE.GPL included in the packaging of
## this file.  Please review the following to ensure GNU General Public
## Licensing requirements will be met:
## http://www.opensource.org/licenses/gpl-license.php
##
## If you are unsure which license is appropriate for your use (for
## instance, you are interested in developing a commercial derivative
## of VisTrails), please contact us at vistrails@sci.utah.edu.
##
## This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
## WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
##
############################################################################
import core.modules
import core.modules.module_registry
from core.modules.vistrails_module import Module, ModuleError

from PDB import *


def initialize(*args, **keywords):
    reg = core.modules.module_registry
    basic = core.modules.basic_modules

    reg.addModule(ProteinDataBank)
    reg.addModule(Protein)

    reg.addModule(PDBParser)
    reg.addInputPort(PDBParser, "File", (basic.File, 'File'))
    reg.addOutputPort(PDBParser, "Protein", (Protein, 'Protein'))

    reg.addModule(GetAtoms)
    reg.addInputPort(GetAtoms, "Protein", (Protein, 'Protein'))
    reg.addInputPort(GetAtoms, "Atom Type", (basic.String, 'AtomType'))
    reg.addOutputPort(GetAtoms, "NumAtoms", (basic.Integer, 'NumAtoms'))

    reg.addModule(GetHetAtoms)
    reg.addInputPort(GetHetAtoms, "Protein", (Protein, 'Protein'))
    reg.addInputPort(GetHetAtoms, "Atom Type", (basic.String, 'AtomType'))
    reg.addOutputPort(GetHetAtoms, "NumAtoms", (basic.Integer, 'NumAtoms'))

    reg.addModule(GetSequence)
    reg.addInputPort(GetSequence, "Protein", (Protein, 'Protein'))
    reg.addInputPort(GetSequence, "SequenceID", (basic.String, 'SequenceID'))
    reg.addOutputPort(GetSequence, "Sequence", (basic.String, 'Sequence'))
